[ARVADOS] updated: 2.1.0-1753-gb65cf0f95
Git user
git at public.arvados.org
Wed Dec 22 18:43:46 UTC 2021
Summary of changes:
discards a5c06be313686fdd04fefe1d43fc9a7fa4c67504 (commit)
discards 75bd93267c0695785f4de91f5070c0de03a5775f (commit)
via b65cf0f95944c8f86802ad0c74ee29e35b6a0a90 (commit)
via a498b0016598ed34b2c957bf11830a52f6ab3931 (commit)
This update added new revisions after undoing existing revisions. That is
to say, the old revision is not a strict subset of the new revision. This
situation occurs when you --force push a change and generate a repository
containing something like this:
* -- * -- B -- O -- O -- O (a5c06be313686fdd04fefe1d43fc9a7fa4c67504)
\
N -- N -- N (b65cf0f95944c8f86802ad0c74ee29e35b6a0a90)
When this happens we assume that you've already had alert emails for all
of the O revisions, and so we here report only the revisions in the N
branch from the common base, B.
Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.
commit b65cf0f95944c8f86802ad0c74ee29e35b6a0a90
Author: Ward Vandewege <ward at curii.com>
Date: Wed Dec 22 13:34:50 2021 -0500
17417: when building the arvados-src, cwltest and libpam-arvados-go
packages, respect the --only-build flag.
Arvados-DCO-1.1-Signed-off-by: Ward Vandewege <ward at curii.com>
diff --git a/build/run-build-packages.sh b/build/run-build-packages.sh
index 5fe176a18..1aa487a7b 100755
--- a/build/run-build-packages.sh
+++ b/build/run-build-packages.sh
@@ -243,33 +243,35 @@ handle_ruby_gem arvados-login-sync
# Python packages
debug_echo -e "\nPython packages\n"
-# arvados-src
-(
- cd "$WORKSPACE"
- COMMIT_HASH=$(format_last_commit_here "%H")
- arvados_src_version="$(version_from_git)"
+if [[ -z "$ONLY_BUILD" ]] || [[ "arvados-src" == "$ONLY_BUILD" ]] ; then
+ # arvados-src
+ (
+ cd "$WORKSPACE"
+ COMMIT_HASH=$(format_last_commit_here "%H")
+ arvados_src_version="$(version_from_git)"
- cd $WORKSPACE/packages/$TARGET
- test_package_presence arvados-src $arvados_src_version src ""
+ cd $WORKSPACE/packages/$TARGET
+ test_package_presence arvados-src $arvados_src_version src ""
- if [[ "$?" == "0" ]]; then
- cd "$WORKSPACE"
- SRC_BUILD_DIR=$(mktemp -d)
- # mktemp creates the directory with 0700 permissions by default
- chmod 755 $SRC_BUILD_DIR
- git clone $DASHQ_UNLESS_DEBUG "$WORKSPACE/.git" "$SRC_BUILD_DIR"
- cd "$SRC_BUILD_DIR"
+ if [[ "$?" == "0" ]]; then
+ cd "$WORKSPACE"
+ SRC_BUILD_DIR=$(mktemp -d)
+ # mktemp creates the directory with 0700 permissions by default
+ chmod 755 $SRC_BUILD_DIR
+ git clone $DASHQ_UNLESS_DEBUG "$WORKSPACE/.git" "$SRC_BUILD_DIR"
+ cd "$SRC_BUILD_DIR"
- # go into detached-head state
- git checkout $DASHQ_UNLESS_DEBUG "$COMMIT_HASH"
- echo "$COMMIT_HASH" >git-commit.version
+ # go into detached-head state
+ git checkout $DASHQ_UNLESS_DEBUG "$COMMIT_HASH"
+ echo "$COMMIT_HASH" >git-commit.version
- cd $WORKSPACE/packages/$TARGET
- fpm_build "$WORKSPACE" $SRC_BUILD_DIR/=/usr/local/arvados/src arvados-src 'dir' "$arvados_src_version" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
+ cd $WORKSPACE/packages/$TARGET
+ fpm_build "$WORKSPACE" $SRC_BUILD_DIR/=/usr/local/arvados/src arvados-src 'dir' "$arvados_src_version" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
- rm -rf "$SRC_BUILD_DIR"
- fi
-)
+ rm -rf "$SRC_BUILD_DIR"
+ fi
+ )
+fi
# Go binaries
cd $WORKSPACE/packages/$TARGET
@@ -343,19 +345,21 @@ build_metapackage "crunchstat-summary" "tools/crunchstat-summary"
build_metapackage "arvados-docker-cleaner" "services/dockercleaner"
build_metapackage "arvados-user-activity" "tools/user-activity"
-# The cwltest package, which lives out of tree
-cd "$WORKSPACE"
-if [[ -e "$WORKSPACE/cwltest" ]]; then
- rm -rf "$WORKSPACE/cwltest"
+if [[ -z "$ONLY_BUILD" ]] || [[ "cwltest" == "$ONLY_BUILD" ]] ; then
+ # The cwltest package, which lives out of tree
+ cd "$WORKSPACE"
+ if [[ -e "$WORKSPACE/cwltest" ]]; then
+ rm -rf "$WORKSPACE/cwltest"
+ fi
+ git clone https://github.com/common-workflow-language/cwltest.git
+ # signal to our build script that we want a cwltest executable installed in /usr/bin/
+ mkdir cwltest/bin && touch cwltest/bin/cwltest
+ fpm_build_virtualenv "cwltest" "cwltest" "python3"
+ # The python->python3 metapackage
+ build_metapackage "cwltest" "cwltest"
+ cd "$WORKSPACE"
+ rm -rf "$WORKSPACE/cwltest"
fi
-git clone https://github.com/common-workflow-language/cwltest.git
-# signal to our build script that we want a cwltest executable installed in /usr/bin/
-mkdir cwltest/bin && touch cwltest/bin/cwltest
-fpm_build_virtualenv "cwltest" "cwltest" "python3"
-# The python->python3 metapackage
-build_metapackage "cwltest" "cwltest"
-cd "$WORKSPACE"
-rm -rf "$WORKSPACE/cwltest"
calculate_go_package_version arvados_server_version cmd/arvados-server
arvados_server_iteration=$(default_iteration "arvados-server" "$arvados_server_version" "go")
diff --git a/build/run-library.sh b/build/run-library.sh
index 686c2b678..dd8e4b274 100755
--- a/build/run-library.sh
+++ b/build/run-library.sh
@@ -206,6 +206,10 @@ package_go_so() {
local pkg="$1"; shift
local description="$1"; shift
+ if [[ -n "$ONLY_BUILD" ]] && [[ "$pkg" != "$ONLY_BUILD" ]]; then
+ return 0
+ fi
+
debug_echo "package_go_so $src_path as $pkg"
calculate_go_package_version go_package_version $src_path
commit a498b0016598ed34b2c957bf11830a52f6ab3931
Author: Ward Vandewege <ward at curii.com>
Date: Wed Dec 22 13:34:07 2021 -0500
17417: add arm64 support for our golang packages, functional for Debian
11 as of this commit.
Arvados-DCO-1.1-Signed-off-by: Ward Vandewege <ward at curii.com>
diff --git a/build/package-build-dockerfiles/debian11/Dockerfile b/build/package-build-dockerfiles/debian11/Dockerfile
index 06380ef89..924c91684 100644
--- a/build/package-build-dockerfiles/debian11/Dockerfile
+++ b/build/package-build-dockerfiles/debian11/Dockerfile
@@ -30,6 +30,12 @@ RUN gpg --import --no-tty /tmp/mpapis.asc && \
ADD generated/go1.17.1.linux-amd64.tar.gz /usr/local/
RUN ln -s /usr/local/go/bin/go /usr/local/bin/
+# Add gcc-aarch64-linux-gnu to compile go binaries for arm64
+RUN /usr/bin/apt-get install -q -y gcc-aarch64-linux-gnu
+# We also need libpam compiled for arm64
+RUN /usr/bin/dpkg --add-architecture arm64
+RUN /usr/bin/apt-get update && /usr/bin/apt-get install -o APT::Immediate-Configure=0 -q -y libpam0g-dev:arm64
+
# Install nodejs and npm
ADD generated/node-v10.23.1-linux-x64.tar.xz /usr/local/
RUN ln -s /usr/local/node-v10.23.1-linux-x64/bin/* /usr/local/bin/
diff --git a/build/run-build-packages-one-target.sh b/build/run-build-packages-one-target.sh
index 7a91cb4de..d52de98a9 100755
--- a/build/run-build-packages-one-target.sh
+++ b/build/run-build-packages-one-target.sh
@@ -21,6 +21,8 @@ Syntax:
Build only a specific package
--only-test <package>
Test only a specific package
+--only-arch <arch>
+ Build only a specific architecture (amd64 or arm64)
--force-build
Build even if the package exists upstream or if it has already been
built locally
@@ -54,13 +56,14 @@ if ! [[ -d "$WORKSPACE" ]]; then
fi
PARSEDOPTS=$(getopt --name "$0" --longoptions \
- help,debug,test-packages,target:,command:,only-test:,force-test,only-build:,force-build,build-version: \
+ help,debug,test-packages,target:,command:,only-test:,force-test,only-build:,force-build,only-arch:,build-version: \
-- "" "$@")
if [ $? -ne 0 ]; then
exit 1
fi
TARGET=debian10
+ONLY_ARCH=
FORCE_BUILD=0
COMMAND=
DEBUG=
@@ -90,6 +93,9 @@ while [ $# -gt 0 ]; do
--only-build)
ONLY_BUILD="$2"; shift
;;
+ --only-arch)
+ ONLY_ARCH="$2"; shift
+ ;;
--debug)
DEBUG=" --debug"
ARVADOS_DEBUG="1"
@@ -311,6 +317,7 @@ else
--env ARVADOS_DEBUG=$ARVADOS_DEBUG \
--env "ONLY_BUILD=$ONLY_BUILD" \
--env "FORCE_BUILD=$FORCE_BUILD" \
+ --env "ONLY_ARCH=$ONLY_ARCH" \
"$IMAGE" $COMMAND
then
echo
diff --git a/build/run-build-packages.sh b/build/run-build-packages.sh
index 26ed168aa..5fe176a18 100755
--- a/build/run-build-packages.sh
+++ b/build/run-build-packages.sh
@@ -22,6 +22,8 @@ Options:
Distribution to build packages for (default: debian10)
--only-build <package>
Build only a specific package (or $ONLY_BUILD from environment)
+--only-arch <architecture>
+ Build only a specific architecture (or $ONLY_ARCH from environment)
--force-build
Build even if the package exists upstream or if it has already been
built locally
@@ -50,7 +52,7 @@ TARGET=debian10
COMMAND=
PARSEDOPTS=$(getopt --name "$0" --longoptions \
- help,build-bundle-packages,debug,target:,only-build:,force-build \
+ help,build-bundle-packages,debug,target:,only-build:,only-arch:,force-build \
-- "" "$@")
if [ $? -ne 0 ]; then
exit 1
@@ -73,6 +75,9 @@ while [ $# -gt 0 ]; do
--force-build)
FORCE_BUILD=1
;;
+ --only-arch)
+ ONLY_ARCH="$2"; shift
+ ;;
--debug)
DEBUG=1
;;
diff --git a/build/run-library.sh b/build/run-library.sh
index ebc1f9e59..686c2b678 100755
--- a/build/run-library.sh
+++ b/build/run-library.sh
@@ -137,9 +137,13 @@ package_go_binary() {
local description="$1"; shift
local license_file="${1:-agpl-3.0.txt}"; shift
- for arch in 'amd64' 'arm64'; do
- package_go_binary_worker "$src_path" "$prog" "$description" "$arch" "$license_file"
- done
+ if [[ -n "$ONLY_ARCH" ]]; then
+ package_go_binary_worker "$src_path" "$prog" "$description" "$ONLY_ARCH" "$license_file"
+ else
+ for arch in 'amd64' 'arm64'; do
+ package_go_binary_worker "$src_path" "$prog" "$description" "$arch" "$license_file"
+ done
+ fi
}
# Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision" [amd64/arm64] [apache-2.0.txt]
@@ -159,19 +163,21 @@ package_go_binary_worker() {
fi
debug_echo "package_go_binary $src_path as $prog"
-
local basename="${src_path##*/}"
calculate_go_package_version go_package_version $src_path
cd $WORKSPACE/packages/$TARGET
- test_package_presence $prog $go_package_version go
-
+ test_package_presence "$prog" "$go_package_version" "go" "" "$arch"
if [[ "$?" != "0" ]]; then
return 1
fi
echo "BUILDING ${arch}"
- GOARCH=${arch} go get -ldflags "-X git.arvados.org/arvados.git/lib/cmd.version=${go_package_version} -X main.version=${go_package_version}" "git.arvados.org/arvados.git/$src_path"
+ if [[ "$arch" == "arm64" ]]; then
+ CGO_ENABLED=1 CC=aarch64-linux-gnu-gcc GOARCH=${arch} go get -ldflags "-X git.arvados.org/arvados.git/lib/cmd.version=${go_package_version} -X main.version=${go_package_version}" "git.arvados.org/arvados.git/$src_path"
+ else
+ GOARCH=${arch} go get -ldflags "-X git.arvados.org/arvados.git/lib/cmd.version=${go_package_version} -X main.version=${go_package_version}" "git.arvados.org/arvados.git/$src_path"
+ fi
local -a switches=()
@@ -346,7 +352,7 @@ test_package_presence() {
fi
local full_pkgname
- get_complete_package_name full_pkgname $pkgname $version $pkgtype $iteration $arch
+ get_complete_package_name full_pkgname "$pkgname" "$version" "$pkgtype" "$iteration" "$arch"
# See if we can skip building the package, only if it already exists in the
# processed/ directory. If so, move it back to the packages directory to make
-----------------------------------------------------------------------
hooks/post-receive
--
More information about the arvados-commits
mailing list